#!/local/paths/perl -wT
#
# 2000/08/30 Sylvain Robitaille: Quick hack to convert Berkeley DB data
#                                file to DBM.

use DB_File;
use NDBM_File;

my ($key, $value);
my ($db_file) = @ARGV;

if(!defined $db_file) {
  die "Usage:\n $0 <filename>\n";
}

# Untaint input:
if( $db_file =~ m%^([^`\\<>|]+)$% ) {
  $db_file = $1;
} else {
  die "$db_file tainted\n";
}

# Open source and destination files:
tie %DB_PW, "DB_File", "$db_file.db", O_RDONLY, 0444, $DB_HASH
   or die "can't dbopen $db_file: $!\n";
tie %DBM_PW, 'NDBM_File', "$db_file", O_RDWR|O_CREAT, 0644
   or die "can't dbmopen $db_file: $!\n";

# translate the input:
while (($key,$value) = each %DB_PW) {
  print "$key $value\n";
  $DBM_PW{$key} = $value;
}

# Close files:
untie %DBM_PW;
untie %DB_PW;

