#!/local/paths/perl -wT
#
# 2000/08/30 Sylvain Robitaille: Quick hack to extract text password
#                                file from DBM file. 

my ($key, $value);
my ($db_file) = @ARGV;

if(!defined $db_file) {
  die "Usage:\n $0 <filename>\n";
}

# Untaint input:
if( $db_file =~ m%^([^`\\<>|]+)$% ) {
  $db_file = $1;
} else {
  die "$db_file tainted\n";
}

dbmopen  %PW, "$db_file", 0666 or die "can't dbmopen $db_file: $!\n";
open  TXTPW, "> $db_file.txt" or die "can't open $db_file.txt: $!\n";

# Make sure we'll be writing to the output file:
my $oldfh = select TXTPW;

# translate the input:
while (($key,$value) = each %PW) {
  $value =~ s/[\0\s]+/:/g;
  $value =~ s/:$//g;
  print "$value\n";
}

# Reset our stdout:
select $oldfh;

close TXTPW;
dbmclose %PW;

